Type TGameObjekt Abstract 

	Field x:Float,y:Float
	Field Sx:Float,Sy:Float
	Field Stepwidth:Float = 1
	Field r:Int,b:Int,g:Int
	Field Show:Byte

	Method SetMove(Kx:Int,Ky:Int)
		Sx = Kx
		Sy = Ky
	End Method
	
	Method GetAngle:Int()
		Return (ATan2(y-sy,x-sx) + 360) Mod 360
	End Method
	
	Method SetColors(red:Int,green:Int,blue:Int)
		r = red
		g = green
		b = blue
	End Method
	
	Method SetToColor()
		SetColor(r,g,b)
		If Dis(Cell) > Gw * 2 Then remove()
	End Method
	
	Method Move:Float[]()
		If Abs(sx - x) < 2 And Abs(sy- y) <2
			x = sx
			y = sy
			Return New Float[2]
		EndIf
		Local vl:Float
		Local Vec:Float[] = New Float[2]
		
		'If Abs(Sx- x) < 1.5 Then x = sx
		'If Abs(Sy- y) < 1.5 Then y = sy
		
		Vec[0] = (sx-x)
		Vec[1] = (sy-y)
		vl = Sqr(Vec[0]*Vec[0] + Vec[1]*Vec[1])
		Vec[0] = Vec[0]/vl
		Vec[1] = Vec[1]/vl
		
		x:+ Vec[0] * Stepwidth
		y:+ Vec[1] * Stepwidth
		Return vec  
	End Method
	
	Method Update()
		Draw()
		Move()
	End Method
	
	Method Draw()
		SetToColor()
	End Method
	
	Method Check()
		If (x - ScreenX) > -200 And (x-screenX) < GW + 200 And (y - screenY) > -200 And (y -screenY) < GH + 200
			Show = True
		Else
			Show = False
		EndIf
	End Method
	Method remove() Abstract 
	
	Method init(Kx:Int,Ky:Int,St:Float = 1)
		x = kx
		sx = x
		y = ky
		sy = y
		stepwidth = st
		SetColors(255,255,255)
	End Method
	
	Method SetPosition(Px:Int,Py:Int)
		x = px
		sx = px
		sy = py
		y=py
	End Method
	
	Method Dis:Float(G:TGameObjekt)
		Local disX:Int = X-g.x
		Local disY:Int = Y-g.y
		Return Sqr(disx*disx + disy*disy)
	End Method
	
	Method Dis2:Float(Gx:Int,Gy:Int)
		Local disX:Int = X-gx
		Local disY:Int = Y-gy
		Return Sqr(disx*disx + disy*disy)
	End Method
	
	Method Eat(C:TCell)
	End Method

End Type

