Global GuiList:TList = New TList
Const LifeAnzeige:Int = -5
Type TGui
	Field X:Int,y:Int
	Field image:TImage
	Field BindTo:Int
	Field C:TCell
	Field Name:String
	Field Wert:String
	
	Method Draw()
		Select Bindto
		Case Amino
			SetColor 255,0,0
		Case Nuclein
			SetColor 0,255,0
		Case Glucose
			SetColor 0,0,255
		Case ATP
			SetColor 255,255,0
		Case LifeAnzeige
			SetColor 255,0,255
		Default
			SetColor 0,255,255
		End Select
		DrawImage image,x,y
		SetColor(255,255,255)
		text2(name,x,y - 11,1,1)
		If bindto >= 0 Then wert = c.resourcen[BindTo]
		text2(wert,x,y + 11,1,1)
	End Method
	
	Method init(x:Int,y:Int,C:TCell,Typ:Int)
		Self.x = x
		Self.y = y
		Self.C = c
		Self.BindTo = Typ
		Select typ
		Case Glucose
			name = "Glucose"
		Case Nuclein
			name = "Nucleinsure"
		Case Amino
			name = "Aminosure"
		Case ATP
			name = "ATP"
		Case LifeAnzeige
			Name = "Leben"
		End Select
		Self.image = imageload("gui")
	End Method
	
End Type

Function CreateGui:TGui(B:Int)
	Local g:TGui = New TGui
		g.init(Guilist.count() * 140 + 75,GH - 64,Cell,b)
		ListAddLast(Guilist,g)
	Return g
End Function


Function DrawGui()
	For Local g:TGui = EachIn Guilist
		g.draw()
	Next
End Function
	

