Global Itemlist:TList = New TList
Const ATP:Int = 3, Glucose:Int = 2,Nuclein:Int = 0, Amino:Int = 1
Type TItem Extends TGameobjekt
	Field image:TImage
	Field Menge:Int[] = New Int[3]
	
	Method Check()
		Super.check()
		If show
			For Local C:TCell = EachIn Celllist
				If dis(c) < cell.radius
					eat(c)
					Return
				EndIf
			Next
		EndIf
	End Method
	
	Method Draw()
		Check()
		If Not Show Then Return
		Super.draw()
		DrawImage image,x - screenx,y - screeny
		If dis(Cell) > GW 
			sx = Cell.x + Rand(0,1) * GW
			sy = Cell.y + Rand(0,1) * GH
			x = sx
			y = sy
		EndIf
		SetColor(255,255,255)
	End Method

	Method Eat(C:TCell)
		Local T:String = ""
		c.resourcen[Nuclein]:+	menge[Nuclein]
		If menge[Nuclein] > 0 Then t:+ "+" + Menge[Nuclein] + " Nucleinsure"
		c.resourcen[Amino]  :+	menge[Amino]
		If menge[Amino] > 0 Then t:+ "+" + Menge[Amino] + " Aminosure"
		c.resourcen[Glucose]:+	menge[Glucose]
		If menge[Glucose] > 0 Then t:+ "+" + Menge[Glucose] + " Glucose"
		CreateMovingText(t,x,y)
		remove()
	End Method
	
	Method remove()
		ListRemove(ItemList,Self)
	End Method
End Type

Function CreateItem(x:Int,y:Int,Nuclein:Int = 0,Amino:Int = 0,Glucose:Int = 0)
	Local i:Titem = New TItem
	i.init(x,y)
	i.menge[1] = Nuclein
	i.menge[0] = Amino
	i.menge[2] = Glucose
	i.SetColors(i.menge[1]*255,i.menge[0]*255,i.menge[2]*255)
	i.image = imageload("item")
	ListAddLast(ItemList,i)
End Function

Function UpdateItems()
	For Local i:Titem = EachIn ItemList
		i.update()
	Next
End Function	
