Global MessageList:TList = New TList,MovingTextList:TList = New TList

Type MovingText
	Field x:Int,y:Int
	Field T:String
	Field Timer:Int
	
	Method Draw()
		Text2 T,x - screenx,y - screeny,1,1
		y:-1
		timer:-1
		If timer <= 0 Then remove()
	End Method
	
	Method Remove()
		ListRemove(MovingTextList,Self)
	End Method
End Type

Function CreateMovingText(T:String,x:Int,y:Int)
	Local tex:MovingText = New MovingText
		tex.t = t
		tex.x = x
		tex.y = y
		tex.timer = 90
		ListAddLast(MovingTextList,tex)
End Function

Function UpdateMovingText()
	For Local mt:Movingtext = EachIn Movingtextlist
		mt.draw()
	Next
End Function

Type TMessage
	Field Value:String
	Field Titel:String
	Field Timer:Int
	Field Do:String
	Field Do2:String
	Field Aim:String[] = New String[2]
	Field ToRemove:Byte
	
	Method CheckAim()
		Select Lower(Aim[0])
		Case "move"
			If maus2 Then remove()
		Case "getatp"
			If Cell.resourcen[ATP] >= Int(aim[1]) Then remove()
		Case "getglucose"
			If Cell.resourcen[Glucose] >= Int(aim[1]) Then remove()
		Case "getenzym"
			If Cell.Enzyme.Count() >= Int(Aim[1]) Then remove()
		Case "getorganelle"
			If Lower(aim[1]) = "endoplasmatisches redikulum"
				If Cell.image <> Kern Then remove()
			Else
				For Local o:Torganelle = EachIn Cell.Organellen
					If Lower(o.name) = Lower(aim[1]) Then remove()
				Next
			EndIf
		Case "survivevirus"
			If Virenlist.isempty() Then remove()
		Case "survivecell"
			If Celllist.count() = 1 Then remove()
		Case "maxhealth"
			If cell.life = cell.maxlife Then remove()
		Case "getpower"
			If cell.power >= Int(aim[1]) Then remove()
		Case "getspeed"
			If cell.speed >= Int(aim[1]) Then remove()
		Case "getresistenz"
			If cell.resistenz >= Int(aim[1]) Then remove()
		Case "gettoxin"
			If cell.toxin >= Int(aim[1]) Then remove()
		Default
			If Maus1 And Mouseoverlape(GW/6,0,Gw * (4.0/6.0),Gh/4) Then remove()
		End Select
	End Method
	
	
	Method GetValue:String()
		While do <> ""
			Local a:String[] = SplitString(do)
			Select(Lower(a[0]))
			Case "addglucose"
				Local x:Int = Int(a[1])
				For Local i:Int = 0 To x
					CreateItem(Rand(0,GW),Rand(0,GH),0,0,Rand(1,6))
				Next
			Case "addamino"
				Local x:Int = Int(a[1])
				For Local i:Int = 0 To x
					CreateItem(Rand(0,GW),Rand(0,GH),50,0,0)
				Next
			Case "addnuclein"
				Local x:Int = Int(a[1])
				For Local i:Int = 0 To x
					CreateItem(Rand(0,GW),Rand(0,GH),0,1,0)
				Next
			Case "addgui"
				CreateGui(Int(a[1]))
			Case "createcell"
				Local c:TCell = CreateCell:TCell(screenx + Rand(-GW/2,gw/2), screeny + Rand(-GH/2,Gh/2),51,AgrCell)
				c.Power = Int(a[1])
				c.setlife(Int(a[2]))
				c.speed = 1.5
				If a.length = 4 Then c.setSpeed(Int(a[3]))
			Case "addviren"
				Local x:Int = Int(a[1])/2
				For Local i:Int = 0 To x
					Local r:Float = Rnd(0,1)
					Local v:Int = sign(Rand(-1,0))
					CreateVirus:TVirus(GW * r ,GH * 1.5 * v ,5)
					CreateVirus:TVirus(GW * 1.5 * v ,GH * r ,5)
				Next
			Default
				DebugLog "Unbekannter Befehl " + Do
			End Select
			do = do2
			do2 = ""
		Wend
		timer:- 1
		If timer = 0 Then remove()
		Return value
	End Method
	
	Method Remove()
		toremove = True
		ListRemove(MessageList,Self)
	End Method
End Type

Function GetMessage:Tmessage()
	If Messagelist.isempty()
		Return Null
	Else
		Return Tmessage(messagelist.first())
	EndIf
End Function

Function GetMessages(File:String = "data/Message.me")
	MessageList.clear()
	Local FP:FileParser = New FileParser
		Fp.read(File)
		Local M:Tmessage = New TMessage
		While fp.isempty() = False
			Local t:Token = fp.getToken()
			Select Lower(t.identifier)
			Case "value"
				m.Value = t.value
			Case "new"
				m = New TMessage
				m.titel = t.value
				m.timer = 4000
				ListAddLast(MessageList,m)
			Case "do"
				m.do = t.value
			Case "do2"
				m.do2 = t.value
			Case "aim"
				Local s:String[] = splitstring(t.value)
				m.aim[0] = s[0]
				Local a:Int = 1
				While a < s.length And s[a] <> " "
					m.aim[1]:+ s[a]
					a:+1
				Wend
				If Left(m.aim[0],1) = " " Then  m.aim[0] = Right(m.aim[0],Len(m.aim[0])-1)
				If Left(m.aim[1],1) = " " Then  m.aim[1] = Right(m.aim[1],Len(m.aim[1])-1)
			End Select
		Wend
End Function

Function UpdateMessage()
	Global Message:TMessage,MValue:TTextArea
	If Cell.Life <= 0 And Cell.removed = False
		If Message <> Null Then Message.remove()
		GetMessages("data/Fail.me")
		If Cell <> Null
			Cell.remove()
		EndIf
	EndIf
	If Message <> Null
			SetAlpha (0.5)
			SetColor (0,0,0)
			DrawRect GW/6,0,Gw * (4.0/6.0),Gh/4
			SetColor 255,255,255
			SetAlpha(1.0)
			
			SetScale(Gw * (4.0/6.0)/3,1)
			DrawImage Strich,Gw * (5.0/6.0),GH/4
			SetRotation(270)
			SetScale(Float(Gh/12) + 1.8,1)
			DrawImage Strich,GW/6,0
			DrawImage Strich,GW * (5.0/6.0),0
			SetRotation(0)
			SetScale(1,1)
			Message.CheckAim()
			Text2(Message.Titel,Gw/2,5,0,1)
			If MValue <> Null Then MValue.draw()
			Message.timer:-1
			If Message.toremove = True And Message.Timer < 3800 Then Message = Null
	ElseIf Message = Null And MessageList.isempty() = False
		Message = GetMessage()
		MValue = CreateTextArea(Message.GetValue(),GW/6 + 5,20,GW * (2.0/3.0) - 10,Gh/4 - 25)
	Else
		SurvivalMode()
	EndIf
End Function


Function SurvivalMode:TMessage()
	Global CoolDown:Int,Wave:Int = 1
		If CoolDown =< 0
			Local r:Int = Rand(0,1),Amount:Int
			Local M:TMessage = New TMessage
			M.Titel = "Wave " + Wave
			If r = 0
				amount = 20 + (Wave * 2)
				m.Value = "Eine Welle von " + Amount + " Viren greift an!"
				m.do = "addviren " + amount
			Else
				amount = 1 + Wave
				m.Value = "Eine Zelle der Strke " + Amount + " Zellen greift an!"
				m.do = "Createcell" + Amount + " " + (Amount * 75) + " " + 1.75
			EndIf
			ListAddLast(MessageList,m)
			CoolDown = 60 * 30
			Return m
		Else
			CoolDown:-1
			Return Null
		EndIf

End Function

		
		





































				
