Const MD:Int = 3, Abstand:Float = 1

Function CreateNode:TNode(LN:TNode,Cell:Tcell)
	Local n:Tnode = New TNode
	n.setposition(cell.x,cell.y)
	n.Ln = Ln
	If ln <> Null Then ln.rn = n
	Return n
End Function
	

Type TNode Extends TGameobjekt

	Field LN:TNode,RN:TNode
	Field MaxDis:Float
	Field MDelay:Int
	Field MoveCounter:Int
	Field Cell:TCell
	Field RelX:Int,RelY:Int
	
	Method GetRelativPosition()
		setmove(Cell.x + RelX,Cell.y + RelY)
	End Method
	
	Method Draw()
		DrawimageLine(Membran,x - screenx,y- screeny,ln.x-screenx,ln.y-screeny,0.4)
		If Abs(x - sx) < Abstand Then x = sx
		If Abs(y - sy) < Abstand Then y = sy
	End Method
	
	Method Move:Float[]()
		Local Vec:Float[]
		If MDelay = 0 And MoveCounter > 0
			If sx <> x Or sy <> y 
				vec = Super.Move()
			EndIf
			MoveCounter:- 1
		Else
			Local sx2:Int,sy2:Int
			
			Rem If dis(cell) > cell.radius * 1.2
				sx2 = sx
				sy2 = sy
				sx  = cell.x + relx
				sy  = cell.y + rely
				Super.move()
				sx = sx2
				sy = sy2
			EndIf 
			EndRem
			
			MDelay:-1
			vec = New Float[2]
		EndIf
		Return vec
	End Method
	
	Method SetRmove(Kx:Int,Ky:Int)
		sx:+ kx
		sy:+ ky
	End Method
	
	Method SetMove(Kx:Int,Ky:Int)
		Mdelay = 0
		Local rx:Int = kx - sx
		Local ry:Int = ky - sy
		Super.setmove(Kx,Ky)
		Local L:Tnode = ln,R:Tnode = rn
		Local Count:Float = 1
		Local Counterwidth:Float = 1
		movecounter = Movecounter/Counterwidth
		
		While (l <> r)
			l.setrmove(rx,ry)
			l.MDelay = 4 * Int(Count)
			l.movecounter = movecounter
			l = l.ln
			
			r.setrmove(rx,ry)
			r.Mdelay = 4 * Int(Count)
			r.movecounter = movecounter
			
			If r = l Then Exit
			r = r.rn
			
			count:+Counterwidth
		Wend
	End Method
	
	Method Remove()
	End Method
End Type






















