Global VirenList:TList = New TList
Global InsideVirenList:TList = New TList
Type TVirus Extends TDGameObjekt
	Field Damage:Int
	Field Phase:Byte
	Field Image:TImage
	Field VDelay:Int
	Field AttactedBy:TEnzym	
	Method GetAngle:Int()
		Return Super.GetAngle() + 180
	End Method
	
	Method Draw()
		SetRotation((getangle() + 270) Mod 360)
		Super.draw()
		If phase <> 2 Then DrawImage image,x-screenx,y-screeny
		SetRotation(0)
	End Method
	
	Method PhaseUp()
		Select Phase
		Case 0
			Local R:Int = Rand(0,100)
			If r < TCell(target).resistenz
				remove()
				Return
			Else
				TCell(target).life:- Damage
			EndIf
			phase:+1
			image = imageLoad("dna")
			ListAddLast(InsideVirenlist,Self)
		Case 1 
			VDelay = 180
			phase:+1
		Case 2
			phase:+1
			Duplicate()
			Duplicate()
			TCell(Target).life:- Damage * 1.5
		Case 3
			Phase:+1
			image = imageload("Virus")
		Case 4
			ListRemove(InsideVirenlist,Self)
			Phase:+1
		End Select
	End Method
	
	Method Duplicate:TVirus()
		Local V:TVirus = createVirus(x,y,Damage,Phase)
		v.image = image
		ListAddLast(insidevirenlist,v)
		Return v
	End Method
	
	Method Move:Float[]()
		Vdelay:-1
		Local difX:Int = Target.x - x
		Local DifY:Int = Target.y - y
		Local dif:Int = Sqr(difx * difx + dify * dify)
		Local Target:Tcell = TCell(target)
		Select Phase
		Case 0
			If dif < Target.Radius
				PhaseUp()
			EndIf
		Case 1
			If dif < 32
				PhaseUp()
			EndIf
		Case 2
			If Vdelay = 0 Then PhaseUp()
		Case 3
			sx = sx + screenx + gw * sign(Rand(-1,0)) * Rnd(0.5,1)
			sy = sy + screeny + gw * sign(Rand(-1,0)) * Rnd(0.5,1)
			PhaseUp()
		Case 4
			If dif > (Target.Radius)
				PhaseUp()
			EndIf
		Case 5
			If Abs(Sx- x)< 5 And Abs(Sy -y) < 5 Then Phase = 0 ; Target = Cell
		End Select
		SetRotation(GetAngle())			 
		Local vec:Float[] = Super.Move()
		SetRotation(0)
		Return vec
	End Method
	
	Method Remove()
		Cell.resourcen[Amino]:+5
		ListRemove(Virenlist,Self)
		ListRemove(InsideVirenlist,Self)
	End Method

End Type

Function CreateVirus:TVirus(x:Int,y:Int,Dmg:Int,Phase:Int = 0)
	Local v:TVirus = New TVirus
	v.target = cell
	v.init(x,y,1.5)
	v.setcolors(255,255,255)
	v.image = imageload("virus")
	v.phase = Phase
	v.damage = dmg
	ListAddLast(Virenlist,v)
	Return v
End Function

Function UpdateViren()
	For Local v:TVirus = EachIn VirenList
		v.update()
	Next
End Function
