Type FileParser
	Field Stream:TStream
	Field Tokenlist:TList = New TList
	
	Method AddToken(Identifier:String,Value:String)
		Local t:Token = New Token
			t.identifier = identifier
			t.Value = value
		ListAddLast(tokenlist,t)
	End Method
	
	Method FindToken:String(Identifier:String)
		For Local t:Token = EachIn Tokenlist
			If Lower(t.identifier) = Lower(identifier) Then Return t.value
		Next
		Return ""
	End Method
	
	Method GetToken:Token()
		Return token(tokenlist.removefirst())
	End Method
	
	Method IsEmpty:Int()
		Return tokenlist.isempty()
	End Method
	
	Method Read(Name:String,Endung:String = "")
		Stream = ReadFile(name + endung)
		If Stream <> Null
			While (Not Stream.Eof())
				Readnextline()
			Wend
			CloseFile(Stream)
		Else
			DebugLog("Konnte den Stream: " + name + endung + " nicht ffnen!")
		EndIf
	End Method
	
	Method Write(Name:String,Endung:String = "")
		Stream:TStream = WriteFile(name + endung)
		For Local t:token = EachIn Tokenlist
			Writenextline(t)
		Next
		CloseFile(Stream)
	End Method
	
	Method WritenextLine(t:Token)
		WriteLine(Stream,"[" + t.Identifier + "]=" + t.value)
	End Method
	 
	Method Readnextline()
		Local start:Int = 0,Ende:Int = 0
		Local Line:String = ReadLine(Stream)
		
		start = Instr(line,"[",ende)
		ende = Instr(line,"]",start)
		
		If start <> ende <> 0
			Local t:Token = New Token
			t.identifier = Mid(line,start+1,(ende - start-1) )
			t.value = Right(line,Len(line) - ende-1)
			ListAddLast(tokenlist,t)
		EndIf
	End Method	
	
	Method Shutdown()
		If stream <> Null Then CloseStream(Stream)
	End Method
	
End Type

Type Token
	Field Value:String
	Field Identifier:String
End Type

