Global ToxinList:TList = New TList

Type TToxin Extends TGameobjekt
	
	Field image:TImage
	Field Owner:TGameObjekt
	Field Dmg:Float
	Field Rotation:Int
	Field vec:Float[] = New Float[2]
	
	Method Move:Float[]()		
		x:+ vec[0] * Stepwidth
		y:+ vec[1] * stepwidth
		Return vec
	End Method	
	
	Method Setmove(Kx:Int,Ky:Int)
		Local vl:Float		
		Vec[0] = (kx-x)
		Vec[1] = (ky-y)
		vl = Sqr(Vec[0]*Vec[0] + Vec[1]*Vec[1])
		Vec[0] = Vec[0]/vl
		Vec[1] = Vec[1]/vl
	End Method
	
	Method Draw()
		Super.Draw()
		SetRotation(Rotation)
		DrawImage image,x - screenx,y - screeny
		Rotation = (Rotation + 1) Mod 360
		SetRotation(0)
		SetColor(255,255,255)
		
		For Local C:Tcell = EachIn Celllist
			If dis(c) < c.radius And c <> owner
				remove()
				c.setlife(-dmg,False)
				Return
			EndIf
		Next
	End Method
	
	Method remove()
		ListRemove(Toxinlist,Self)
		Owner = Null
	End Method
	
End Type

Function CreateToxin(O:TOrganelle)
	Local C:TCell = TCell(o.bind)
	
	Local t:TToxin = New TToxin
	t.owner = c
	t.image = imageload("enzym")
	t.init(c.x,c.y,2)
	t.setcolors(0,255,0)
	t.setmove(MouseX() + screenx,MouseY() + screeny)
	t.dmg = c.toxin * 3
	ListAddLast(Toxinlist,t)
End Function

Function UpdateToxin()
	For Local t:TToxin = EachIn Toxinlist
		t.draw()
		t.move()
	Next
End Function
	

	
