Global MausX:Int,MausY:Int,Maus1:Byte,Maus2:Byte,Maus3:Byte,MausXSpeed:Int,MausySpeed:Int,MausZSpeed:Float
Global Loadedimagelist:TList = New TList

Function MouseUpdate()
	MausX = MouseX()
	MausY = MouseY()
	Maus1 = MouseHit(1)
	Maus2 = MouseHit(2)
	Maus3 = MouseHit(3)
	MausXSpeed = MouseXSpeed()
	MausYSpeed = MouseYSpeed()
	MausZSpeed = MouseZSpeed()
End Function

Function FPS(x:Int,y:Int)
	Global Frame:Int,Frametimer:Int,Out_Frame:Int
	If frametimer + 1000 < MilliSecs()
		frametimer = MilliSecs()
		Out_frame = frame
		frame = 0
	EndIf
	frame = frame + 1
	SetColor 255,255,255
	DrawText "FPS: " + Out_frame,x,y
	SetColor 255,255,255
End Function

Function Mouseoverlape:Byte(x:Int,y:Int,w:Int,h:Int)
	If Mausx >= x And mausx <= x + w And mausy >= y And mausy <= y + h Then Return True
	Return False
End Function

Function sign:Float(x:Float)
	If x < 0 Then Return -1
	Return 1
End Function

Type T_Ana_image
	Field image:TImage
	Field T:String	
End Type

Function Imageload:TImage(Name$,ani:Byte = False)
	Local a:T_Ana_image
	For a = EachIn Loadedimagelist
		If a.t = name Then Return a.image
	Next
	a = Image_add(Name$,ani)
	Return a.image
End Function

Function image_add:T_ana_image(Name$,ani:Byte,endung$ = ".png")
	name = Lower(name)
	endung = Lower(endung)
	Local a:T_ana_image = New T_ana_image
		If ani = False Then 
			a.image = LoadImage("gfx/" + name + endung,MASKEDIMAGE)
		Else
			Local t:TImage =LoadImage("gfx/" + name + endung)
			If t <> Null Then a.image = LoadAnimImage("gfx/" + name + endung,ImageHeight(t),ImageHeight(t),0,ImageWidth(t)/ImageHeight(t))
		EndIf
		MidHandleImage(a.image)
		a.t = Name
		ListAddLast(Loadedimagelist,a)
	Return a
End Function

Function Textarea:String (t$,pX:Int,pY:Int,w:Int,h:Int)
Local ny:Int,nx:Int,i:Int,lt:Int,Zeilenumbruch:Int,nt$,zeilen:Int,j:Int
t = t + " "
	nx = pX
  	ny = pY
    zeilen = 0
    nt$ = ""
    i = 0
    lt = Len(t$)
   While Len(t$) > 0
      i = i + 1
      Zeilenumbruch = Instr (t$,"\")
	  If i = zeilenumbruch 
		If ny  >= pY Then DrawText nt$,nx, ny
         t$ = Mid$(t$, i + 1, -1)
         i = 0
         nt$ = ""                                       
         ny = ny + 1.2 * TextHeight(t$) * 0.8
        zeilen = zeilen + 1
        If (zeilen + 1) * (1.2 * TextHeight(t$) * 0.8) => h Then Exit
      ElseIf TextWidth(Left$(t$, i)) < w And i <= Len(t$) Then
         nt$ = Left$(t$, i)
      Else
        For j = Len(nt$) To 1 Step -1
         If Mid$(nt$, j, 1) = " " Then
            nt$ = Left$(nt$, j)
            i = j + 1
            Exit
         End If
        Next            
      
         If ny >= pY Then DrawText nt$,nx, ny
         t$ = Mid$(t$, i, -1)
         i = 0
         nt$ = ""                                       
         ny = ny + 1.2 * TextHeight(t$) * 0.8
        zeilen = zeilen + 1
        If (zeilen + 1 ) * TextHeight(t$) => h Then Exit
      End If
   Wend
	Return t
End Function

Function Zeilenumbrechen:String[](t$,w:Int,h:Int)
	Local S:String[] = SplitString(t)
	Local re:String[] = New String[h/TextHeight(T) + 1]
	Local a:Int = 0,b:Int = 0
	While a < re.length And b < s.length
		If Left(s[b],1) = "\" Then s[b] = Right(s[b],Len(s[b])-1)
		While b < s.length And TextWidth(re[a]) + TextWidth(s[b]) < w  And Left(s[b],1) <> "\" 
			If re[a] <> "" 
				re[a]:+ " " + s[b]
			Else
				re[a]:+ s[b]
			EndIf
			b:+1
		Wend
		
		a:+1
	Wend
	Return re
End Function

Type TTextArea
	Field x:Int,y:Int
	Field T:String[]
	
	Method Draw()
		Local a:Int
		While a < t.length
			DrawText t[a],x,y + TextHeight(t[a]) * a
			a:+1
		Wend
	End Method
	
End Type

Function CreateTextArea:TTextArea(t:String,x:Int,y:Int,w:Int,h:Int)
	If t = "" Or t = " " Then Return Null
	Local tex:TTextArea = New TTextarea
		tex.t = Zeilenumbrechen(t,w,h)
		tex.x = x
		tex.y = y
	Return tex
End Function

Function Text2(t$,x:Int,y:Int,w:Int = 0,h:Int = 0)
	If h = True Then x = x - TextWidth(t)/2
	If w = True Then y = y - TextHeight(t)/2
	DrawText t,x,y
End Function

Function SplitString:String[](S:String,C:String = " ")
	
	Local Pos:Int = 1
	Local Counter:Int = 1
	While (pos <> 0)
		pos = Instr(s,c,pos+1)
		If pos <> 0 Then counter:+1
	Wend
	Local T:String[] = New String[Counter +1]
	Pos:Int = 1
	Counter:Int = 0
	
	While (pos <> 0)
		pos = Instr(s,c)
		If pos <> 0 
			t[counter] = Mid(s,0,pos)
		Else
			t[counter] = Mid(s,0)
		EndIf
		s = Right(s,Len(s)-Len(t[counter]) - Len(c))
		counter:+1
	Wend
	
	Return t
End Function

Function DrawimageLine(Image:TImage,x1:Float,y1:Float,x2:Int,y2:Int,Above:Float = 0.333)
	Local ScaleX:Float,ScaleY:Float,Rotation:Float
	GetScale(ScaleX,ScaleY)
	Rotation = GetRotation() 
	Local DifX:Float =(x1 - x2)
	Local DifY:Float =(y1 - y2)
	Local Dif:Float = Sqr(difx*difx+dify*dify)
	SetScale(dif * Above,1)
	SetRotation((ATan2(dify,difx) + 360) Mod 360)
	Local a:Int = x1 + difx/2
	Local b:Int = y1 + dify/2
	DrawImage image,x1,y1
	SetScale(ScaleX,ScaleY)
	SetRotation(Rotation)
End Function

Function round:String(Value:Float,Stellen:Int)
		Local z:Int = value * 10^stellen
		Return Int(Value) + "." + Right(z,stellen)
End Function